/************************************************/
/*						*/
/*      Copyright:				*/
/*	 Jean-Marc Pigeon <jmp@safe.ca>	 2009	*/
/*						*/
/************************************************/
/* This program is free software; you can 	*/
/* redistribute it and/or modify it under the 	*/
/* terms of the GNU General Public License as	*/
/* published by the Free Software Foundation	*/
/* version 2 of the License			*/
/*						*/
/* This program is distributed in the hope that */
/* it will be useful, but WITHOUT ANY WARRANTY; */
/* without even the implied warranty of		*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR	*/
/* PURPOSE.  See the GNU General Public License	*/
/* for more details.				*/
/*						*/
/* You should have received a copy of the GNU	*/
/* General Public License along with this 	*/
/* program; if not, write to the Free Software	*/
/* Foundation, Inc., 51 Franklin Street,	*/
/* Fifth Floor, Boston, MA  02110-1301, USA.	*/
/************************************************/
/*						*/
/*	Define module level routines to handle	*/
/*	syntaxic analyze of the E-mail header	*/
/*	part.					*/
/*						*/
/************************************************/
#ifndef GESHDR
#define GESHDR
#include	<time.h>

typedef	enum	{	/*mail originator	*/
	org_smtp,	/*'mail from: '		*/
	org_from,	/*mail from:		*/
	org_sender,	/*mail Sender:		*/
	org_replyto	/*mail Reply-To:	*/
	}ORGENUM;

typedef	struct	{	/*Email header info	*/
	int nbrerror;	/*number of syntax error*/
	time_t cachet;	/*message stamping date	*/
	ORGENUM org;	/*real from info	*/
	char *realfrom;	/*real E-mail originator*/
	char *msgid;	/*E-mail msgid		*/
	char *subject;	/*E-mail subject line	*/
	char *virname;	/*Virus name if Virus	*/
	char **distlist;/*distribution list	*/
	char **inrplyto;/*MSG Reply-To unique id*/
	char *spamlvl;	/*spam level		*/
	}EVLTYP;

extern EVLTYP *hdr_parseheader(char *session,char **headers);
extern EVLTYP *hdr_freeevl(EVLTYP *evl);
#endif
