/************************************************/
/*						*/
/*      Copyright:				*/
/*	 Jean-Marc Pigeon <jmp@safe.ca>	 2009	*/
/*						*/
/************************************************/
/* This program is free software; you can 	*/
/* redistribute it and/or modify it under the 	*/
/* terms of the GNU General Public License as	*/
/* published by the Free Software Foundation	*/
/* version 2 of the License			*/
/*						*/
/* This program is distributed in the hope that */
/* it will be useful, but WITHOUT ANY WARRANTY; */
/* without even the implied warranty of		*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR	*/
/* PURPOSE.  See the GNU General Public License	*/
/* for more details.				*/
/*						*/
/* You should have received a copy of the GNU	*/
/* General Public License along with this 	*/
/* program; if not, write to the Free Software	*/
/* Foundation, Inc., 51 Franklin Street,	*/
/* Fifth Floor, Boston, MA  02110-1301, USA.	*/
/************************************************/
/*						*/
/*	GESIPC					*/
/*	Define management level for memory	*/
/*	used to exchange message between 	*/
/*	process.				*/
/*						*/
/************************************************/
#ifndef GESIPC
#define GESIPC
#include	<unistd.h>
#include	"uniipc.h"


#define	ONEWAY	"0:0"	/*one way messages	*/

typedef	void BOXTYP;

extern BOXTYP *ipc_getbox(int boxsize);
extern BOXTYP *ipc_dropbox(BOXTYP *box);
extern void ipc_cleanbox(BOXTYP *box);
extern char *ipc_postmsg(BOXTYP *box,pid_t destination,char *msg);
extern char *ipc_getpost(BOXTYP *box,char **msgref,u_long *millisec);
extern char *ipc_getreply(BOXTYP *box,char *msgref);
extern int ipc_postreply(BOXTYP *box,char *msgref,char *msg);
extern int ipc_relaymsg(BOXTYP *box,char *msgref,pid_t destination,char *msg);
extern char *ipc_getonemsgref(BOXTYP *box);
extern void ipc_purgemsgs(BOXTYP *box,pid_t rcpt);
extern int ipc_waitpost(BOXTYP *box,TIMESPEC *timeout);
#endif
