/************************************************/
/*						*/
/*      Copyright:				*/
/*	 Jean-Marc Pigeon <jmp@safe.ca>	 2009	*/
/*						*/
/************************************************/
/* This program is free software; you can 	*/
/* redistribute it and/or modify it under the 	*/
/* terms of the GNU General Public License as	*/
/* published by the Free Software Foundation	*/
/* version 2 of the License			*/
/*						*/
/* This program is distributed in the hope that */
/* it will be useful, but WITHOUT ANY WARRANTY; */
/* without even the implied warranty of		*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR	*/
/* PURPOSE.  See the GNU General Public License	*/
/* for more details.				*/
/*						*/
/* You should have received a copy of the GNU	*/
/* General Public License along with this 	*/
/* program; if not, write to the Free Software	*/
/* Foundation, Inc., 51 Franklin Street,	*/
/* Fifth Floor, Boston, MA  02110-1301, USA.	*/
/************************************************/
/*						*/
/*	Define routine to manage a TSL 		*/
/*	(uncrypted/crypted) channel.		*/
/*						*/
/************************************************/
#ifndef GESTLS
#define GESTLS
#include	"unidev.h"

typedef void TLSFILE;

extern int tls_getfeed(TLSFILE *tlsfile);
extern int tls_write(TLSFILE *tls,char *buffer,int parnum);
extern TLSFILE *tls_accept(LSTTYP *lst);
extern int tls_gotls(TLSFILE *tls,int accepting);
extern char *tls_getcipher(TLSFILE *tls);
extern int tls_close(TLSFILE *tls);
extern int tls_printf(TLSFILE *tls,const char *fmt,...);
extern char *tls_fgets(char *s,int size,TLSFILE *tlsfile);
extern char *tls_getaddrname(TLSFILE *tlsfile,PEERTYP peer,char *unknown);
extern TLSFILE *tls_opentcp(char *addrname,int port,int swait);
extern int tls_waitforchar(TLSFILE *tlsfile,u_int millisec);
extern char *tls_waitforaction(int secwait,TLSFILE *tlsfile);
extern int tls_iseof(TLSFILE *tlsfile);
extern u_long tls_idle(TLSFILE *tlsfile);
extern char **tls_getb64(char **lst,const char *b64);
#endif
