/************************************************/
/*						*/
/*      Copyright:				*/
/*	 Jean-Marc Pigeon <jmp@safe.ca>	 2009	*/
/*						*/
/************************************************/
/* This program is free software; you can 	*/
/* redistribute it and/or modify it under the 	*/
/* terms of the GNU General Public License as	*/
/* published by the Free Software Foundation	*/
/* version 2 of the License			*/
/*						*/
/* This program is distributed in the hope that */
/* it will be useful, but WITHOUT ANY WARRANTY; */
/* without even the implied warranty of		*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR	*/
/* PURPOSE.  See the GNU General Public License	*/
/* for more details.				*/
/*						*/
/* You should have received a copy of the GNU	*/
/* General Public License along with this 	*/
/* program; if not, write to the Free Software	*/
/* Foundation, Inc., 51 Franklin Street,	*/
/* Fifth Floor, Boston, MA  02110-1301, USA.	*/
/************************************************/
/*						*/
/*	MNGUSR:					*/
/*	Module level routines to handle		*/
/*	E-mail RCPT request by checking	with	*/
/*	local sender and remote Mentor.		*/
/*						*/
/************************************************/
#include	<stdlib.h>
#include	<unistd.h>
#include	<malloc.h>
#include	<syslog.h>
#include	<string.h>
#include	<errno.h>
#include	<string.h>
#include	"subrou.h"
#include	"unieml.h"
#include	"unicac.h"
#include	"gesque.h"
#include	"gescnf.h"
#include	"lvleml.h"
#include	"mngusr.h"
/*

*/
/************************************************/
/*						*/
/*	Procedure to request an advice from	*/
/*	a Mentor about recipient willingness	*/
/*	to accepT E-mail from originator.	*/
/*						*/
/************************************************/
void usr_rqstadv(CHKTYP *checker,char *msgref,char *msg,int num,int slice)

{
char *advrqt;

advrqt=rou_memstrcat((char *)0,"%s %d/%d %s",ADVICE,num,slice,msg);
(void) eml_sendstream(checker->contact,RQSTID,msgref,advrqt);
advrqt=rou_freestr(advrqt);
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to send a "sent report" to 	*/
/*	remote mentor.				*/
/*						*/
/************************************************/
void usr_tobesent(CHKTYP *checker,char *msgref,char *msg,char *head)

{
char *sntrpt;

sntrpt=rou_memstrcat((char *)0,"%s %s",head,msg);
(void) eml_sendstream(checker->contact,RQSTID,msgref,sntrpt);
sntrpt=rou_freestr(sntrpt);
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to check if a user is		*/
/*	existing at local level.		*/
/*	before to submit request to mentor	*/
/*						*/
/************************************************/
int usr_isexisting(CHKTYP *checker,char *caller,RCPTMSG *rm)

{
PLDTYP *payload;
int chkstatus;
PLDTYP pld;
int phase;
int proceed;

payload=(PLDTYP *)0;
chkstatus=ERRPROC;
(void) memset(&pld,'\000',sizeof(pld));
pld.type=pldsmstat;
phase=0;
proceed=true;
while (proceed==true) {
  switch (phase) {
    case  0		:	/*set rcpt status	*/
      if ((payload=cac_getentry(rm->rcpt,pldsmstat))!=(PLDTYP *)0) {
	chkstatus=payload->info.smstat.status;
	if (chkstatus!=0)
	  proceed=false;	/*found real a status	*/
	}
      break;
    case  1		:	/*is the checker up?	*/
      if (checker==(CHKTYP *)0) {
	chkstatus=NOSNDR;
	proceed=false;
	}
      break;
    case  2		:	/*finding direct sender	*/
      (void) eml_checkuser(checker,caller,rm->rqst,rm->rcpt,rm->xrelais,&pld);
      break;
    default		:	/*SAFE Guard			*/
      chkstatus=pld.info.smstat.status;
      switch (chkstatus) {
	case RELAYOK	:
	  pld.info.smstat.status=CMDOK;
	  break;
	default		:
	  break;
        }
      (void) cac_setentry(rm->rcpt,&pld);
      pld.info.smstat.str=rou_freestr(pld.info.smstat.str);
      proceed=false;
      break;
    }
  phase++;
  }
if ((chkstatus==CMDOK)&&(rm->xrelais==true))
  chkstatus=RELAYOK;
return chkstatus;
}
